//+------------------------------------------------------------------+
//|                                                 ADX_coloured.mq4 |
//|                                                   Piotr Lisowski |
//|                                          piotr.lisowski@achem.pl |
//+------------------------------------------------------------------+
#property copyright "Copyright  2004, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net/"

#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1 LightSeaGreen // base
#property indicator_color2 Yellow // no trend
#property indicator_color3 Magenta  // turning
#property indicator_color4 Lime    // trend

//---- input parameters
extern int ADXPeriod=14;
extern int ref_level=20;
extern int trend_level=30;

//---- buffers
double ADXBuffer_0[];
double ADXBuffer_1[];
double ADXBuffer_2[];
double ADXBuffer_3[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- 3 additional buffers are used for counting.
   IndicatorBuffers(4);
//---- indicator buffers
   SetIndexBuffer(0,ADXBuffer_0);
   SetIndexBuffer(1,ADXBuffer_1);
   SetIndexBuffer(2,ADXBuffer_2);
   SetIndexBuffer(3,ADXBuffer_3);
   
//---- name for DataWindow and indicator subwindow label
   IndicatorShortName("ADX("+ADXPeriod+")");
   SetIndexLabel(0,"ADX_0");
   SetIndexLabel(1,"ADX_1");
   SetIndexLabel(2,"ADX_2");
   SetIndexLabel(3,"ADX_3");

//----
   SetIndexDrawBegin(0,ADXPeriod);
   SetIndexDrawBegin(1,ADXPeriod);
   SetIndexDrawBegin(2,ADXPeriod);
   SetIndexDrawBegin(3,ADXPeriod);
   SetIndexStyle(0, DRAW_LINE, STYLE_SOLID);
   SetIndexStyle(1, DRAW_LINE, STYLE_SOLID);
   SetIndexStyle(2, DRAW_LINE, STYLE_SOLID);
   SetIndexStyle(3, DRAW_LINE, STYLE_SOLID);

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Average Directional Movement Index                               |
//+------------------------------------------------------------------+
int start()
  {
 
//---- 
    int limit;
   int counted_bars=IndicatorCounted();
   if(counted_bars<0) counted_bars=0;
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;

   double adx_0,adx_1,dmip_0,dmip_1,dmim_0,dmim_1;
   
   for(int i = 0 ;i < limit ;i++)
   {
      
 
      adx_0 = iADX(NULL,0,ADXPeriod,PRICE_CLOSE,0,i);
      ADXBuffer_0[i] = adx_0;    
      if(adx_0< ref_level) 
      {//no trend
         ADXBuffer_1[i] = adx_0;
         ADXBuffer_2[i] = EMPTY_VALUE;
         ADXBuffer_3[i] = EMPTY_VALUE;
      }
      else if(adx_0<trend_level) 
      { // almost
         ADXBuffer_1[i] = EMPTY_VALUE;
         ADXBuffer_2[i] = adx_0;
         ADXBuffer_3[i] = EMPTY_VALUE;
      }
      else {
         ADXBuffer_1[i] = EMPTY_VALUE;
         ADXBuffer_2[i] = EMPTY_VALUE;
         ADXBuffer_3[i] = adx_0;
       }
   }  
//----
 

   return(0);
  }
//+------------------------------------------------------------------+